(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('styled-components'), require('react')) :
  typeof define === 'function' && define.amd ? define(['exports', 'styled-components', 'react'], factory) :
  (factory((global.reactGridFlexbox = {}),global.styled,global.React));
}(this, (function (exports,styled,React) { 'use strict';

  styled = styled && styled.hasOwnProperty('default') ? styled['default'] : styled;

  var defaultBreakpoints = {
      tn: '0px', xs: '500px', sm: '768px', md: '992px',
      lg: '1200px', xl: '1440px', hg: '1920px'
  };
  var composeCSSMedia = function composeCSSMedia(cssProp, value, defaultValue) {
      var parseValue = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : function (_value) {
          return _value;
      };

      if (typeof value === 'string') {
          return cssProp + ': ' + parseValue(value) + ';';
      } else if (value === Object(value)) {
          return Object.keys(value).reduce(function (mediaString, key) {
              return '\n      ' + mediaString + '\n      @media (min-width: ' + (defaultBreakpoints[key] ? defaultBreakpoints[key] : key) + ') {\n        ' + cssProp + ': ' + parseValue(value[key]) + ';\n      }\n    ';
          }, '');
      }
      return defaultValue ? cssProp + ': ' + parseValue(defaultValue) + ';' : '';
  };

  var taggedTemplateLiteral = function (strings, raw) {
    return Object.freeze(Object.defineProperties(strings, {
      raw: {
        value: Object.freeze(raw)
      }
    }));
  };

  var _templateObject = taggedTemplateLiteral(['\n  ', '\n'], ['\n  ', '\n']);
  var StyledGridItem = styled('div')(_templateObject, function (p) {
    return composeCSSMedia('grid-area', p._gridArea, 'auto');
  });

  var GridItem = function GridItem(props) {
    return React.createElement(StyledGridItem, { _gridArea: props._gridArea }, props.children);
  };

  var _templateObject$1 = taggedTemplateLiteral(['\n  display: grid;\n  ', '\n  ', '\n  ', '\n  ', '\n  ', '\n'], ['\n  display: grid;\n  ', '\n  ', '\n  ', '\n  ', '\n  ', '\n']);
  var StyledGridItem$1 = styled('div')(_templateObject$1, function (p) {
    return composeCSSMedia('grid-template-columns', p.templateColumns, 'auto');
  }, function (p) {
    return composeCSSMedia('grid-template-rows', p.templateRows, 'auto');
  }, function (p) {
    return composeCSSMedia('grid-template-areas', p.templateAreas);
  }, function (p) {
    return composeCSSMedia('grid-gap', p.gutter, '0px');
  }, function (p) {
    return p.incGutterEdges ? function (p) {
      return composeCSSMedia('padding', p.gutter);
    } : '';
  });

  var Grid = function Grid(props) {
      var gridChildren = React.Children.map(props.children, function (child) {
          // Wrap any children in a div to prevent potential css flex layout overrides.
          if (child) {
              var gridChildProps = {
                  '_gridArea': child.props._gridArea
              };
              var childPropsWithoutFlexProps = Object.assign({}, child.props);
              Object.keys(gridChildProps).forEach(function (key) {
                  delete childPropsWithoutFlexProps[key];
              });
              var wrapped = React.createElement('div', gridChildProps, child.props ? Object.assign({}, child, { props: childPropsWithoutFlexProps }) : child);
              return React.createElement(GridItem, { children: wrapped.props.children, _gridArea: wrapped.props._gridArea });
          }
          return null;
      });
      var jsx = function jsx() {
          return React.createElement(StyledGridItem$1, { templateRows: props.templateRows, templateColumns: props.templateColumns, templateAreas: props.templateAreas, gutter: props.gutter, incGutterEdges: props.incGutterEdges }, gridChildren);
      };
      return props.className ? React.createElement("div", { className: props.className }, jsx()) : jsx();
  };

  var _templateObject$2 = taggedTemplateLiteral(['\n  ', '\n  ', '\n  ', '\n  ', '\n  ', '\n'], ['\n  ', '\n  ', '\n  ', '\n  ', '\n  ', '\n']);
  var StyledFlexItem = styled('div')(_templateObject$2, function (p) {
    return composeCSSMedia('padding', p.gutterSize, null, function (value) {
      return 'calc(' + value + ' / 2)';
    });
  }, function (p) {
    return p._flexBasis ? '\n    ' + function (p) {
      return composeCSSMedia('flex-basis', p._flexBasis, 'auto');
    } + '\n  ' : '';
  }, function (p) {
    return p._flexGrow ? '\n    flex-grow: 1;\n  ' : '';
  }, function (p) {
    return p._flexScroll ? '\n    > * {\n      ' + function (p) {
      return composeCSSMedia('max-width', p.gutterSize, '0px', function (value) {
        return 'calc(100% - ' + value + ')';
      });
    } + '\n      ' + function (p) {
      return composeCSSMedia('max-heigth', p.gutterSize, '0px', function (value) {
        return 'calc(100% - ' + value + ')';
      });
    } + '\n      overflow: auto;\n    }\n  ' : '';
  }, function (p) {
    return p._flexReset ? '\n    position: relative;\n    > * {\n      position: absolute;\n      ' + function (p) {
      return composeCSSMedia('min-width', p.gutterSize, '100%', function (value) {
        return 'calc(100% - ' + value + ')';
      });
    } + '\n      ' + function (p) {
      return composeCSSMedia('min-height', p.gutterSize, '100%', function (value) {
        return 'calc(100% - ' + value + ')';
      });
    } + '\n    }\n  ' : '';
  });

  var FlexItem = function FlexItem(props) {
      var jsx = function jsx() {
          return props._flexScroll || props._flexReset ? React.createElement("div", null, props.children) : props.children;
      };
      return React.createElement(StyledFlexItem, { gutterSize: props.gutterSize, _flexBasis: props._flexBasis, _flexGrow: props._flexGrow, _flexScroll: props._flexScroll, _flexReset: props._flexReset }, jsx());
  };

  var _templateObject$3 = taggedTemplateLiteral(['\n  display: flex;\n  align-content: flex-start;\n  ', '\n  flex-wrap: ', ';\n  ', '\n  ', '\n  ', '\n\n  > * {\n    max-width: 100%;\n  }\n'], ['\n  display: flex;\n  align-content: flex-start;\n  ', '\n  flex-wrap: ', ';\n  ', '\n  ', '\n  ', '\n\n  > * {\n    max-width: 100%;\n  }\n']);
  var composeAlignment = function composeAlignment(props) {
    var alignMap = {
      top: 'flex-start',
      bottom: 'flex-end',
      left: 'flex-start',
      right: 'flex-end',
      center: 'center',
      middle: 'center'
    };
    return '\n    ' + (props.vAlign ? (props.isRow ? 'align-items' : 'justify-content') + ': ' + alignMap[props.vAlign] + ';' : '') + '\n    ' + (props.hAlign ? (props.isRow ? 'justify-content' : 'align-items') + ': ' + alignMap[props.hAlign] + ';' : '') + '\n  ';
  };
  var StyledFlex = styled('div')(_templateObject$3, function (p) {
    return p.direction ? 'flex-direction: ' + function (p) {
      return p.direction;
    } + ';' : '';
  }, function (p) {
    return p.wrap;
  } && function (p) {
    return p.isRow;
  } ? 'wrap' : 'nowrap', function (p) {
    return composeAlignment(p);
  }, function (p) {
    return p.incGutterEdges ? '\n    margin: 0;\n    ' + function (p) {
      return composeCSSMedia('padding', p.gutter, null, function (value) {
        return 'calc(' + value + ' / 2)';
      });
    } + '\n  ' : '\n    ' + function (p) {
      return composeCSSMedia('margin', p.gutter, null, function (value) {
        return 'calc(-' + value + ' / 2)';
      });
    } + '\n  ';
  }, function (p) {
    return p.full ? '\n    ' + function (p) {
      return composeCSSMedia('min-width', p.gutter, '0px', function (value) {
        return 'calc(100% + ' + value + ')';
      });
    } + '\n    ' + function (p) {
      return composeCSSMedia('min-height', p.gutter, '0px', function (value) {
        return 'calc(100% + ' + value + ')';
      });
    } + '\n  ' : '';
  });

  var Flex = function Flex(props) {
      var flexChildren = React.Children.map(props.children, function (child) {
          // Wrap any children in a div to prevent potential css flex layout overrides.
          if (child) {
              var wrappedFlexChildProps = child.props ? Object.keys(child.props).reduce(function (props, key) {
                  if (key !== 'className') {
                      props[key] = child.props[key];
                  }
                  return props;
              }, {}) : {};
              var childPropsWithoutFlexProps = Object.assign({}, child.props);
              Object.keys(wrappedFlexChildProps).forEach(function (key) {
                  delete childPropsWithoutFlexProps[key];
              });
              var wrapped = React.createElement('div', wrappedFlexChildProps, child.props ? Object.assign({}, child, { props: childPropsWithoutFlexProps }) : child);
              return React.createElement(FlexItem, { children: wrapped.props.children, gutterSize: wrapped.props.gutter, _flexBasis: wrapped.props._flexBasis, _flexGrow: wrapped.props._flexGrow, _flexScroll: wrapped.props._flexScroll, _flexReset: wrapped.props._flexReset });
          }
          return null;
      });
      var jsx = function jsx() {
          return React.createElement(StyledFlex, { direction: props.direction ? props.direction : 'column', vAlign: props.vAlign, hAlign: props.hAlign, gutter: props.gutter, full: props.full, wrap: props.wrap, incGutterEdges: props.incGutterEdges }, flexChildren);
      };
      return props.className ? React.createElement("div", { className: props.className }, jsx()) : jsx();
  };

  exports.Grid = Grid;
  exports.Flex = Flex;

  Object.defineProperty(exports, '__esModule', { value: true });

})));
